/**********************************************************************
 
	Copyright (C) 2003 Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/



#include	"memory_debug.h"
#include	"pdb.h"

PDB_REQUEST * pr_free_list;

int insert_time;

void
insert_request(PDB * p,unsigned int fofs,void * opt)
{
PDB_REQUEST * pr;
PDB_REQUEST ** prp;


	if ( fofs < p->fofs )
		prp = &p->next_request;
	else 	prp = &p->request;
	for ( ; *prp ; prp = &(*prp)->next )
		if ( (*prp)->fofs > fofs )
			break;
	if ( pr_free_list == 0 )
		pr = d_alloc(sizeof(*pr));
	else {
		pr = pr_free_list;
		pr_free_list = pr->next;
	}
	pr->fofs = fofs;
	pr->option = opt;
	pr->next = *prp;
	*prp = pr;
}


